<?php

if (!defined("TE_OK")) die("fuck off");

/**
 * 
 * @version 0.1
 * @author Iurii Korotia <ykorotia@hotmail.com>
 * @copyright Iurii Korotia, fixfixed.com
 * @license GNU GPLv3, http://www.gnu.org/licenses/gpl.html

 */
class TE_Manager
{
    /**
     * constants go here
     * 
     */
    static private $Table_Locations = "TE_Locations";
    static private $Table_Ranks = "TE_Ranks";
    static private $Table_Awards = "TE_Awards";
    static private $Table_Groups = "TE_Groups";
    static private $Table_Members = "TE_Members";
    static private $Table_AwardsList = "TE_AwardsList";
    
    
    static private $LastError;
    
    /**
     * NOT IMPLEMENTED
     * */
    public function LastError() { return self::$LastError; }
    
    
    
    
    
    
    // ============================================================================================================================================
    // ============================================== GLOBAL FREQUENTLY USED FUNCTIONS ============================================================
    // ============================================================================================================================================
    
    
    /**
     * escapes " as \" for use in input box
     * 
     * NOT USED. RESERVED FOR FUTHER USE
     */ 
    static function quote_esc ($string)
    {
        return str_replace(array('\\','"'),array('\\\\','\\"'),$string);
    }
    
    
    
    
    /**
     * gets datetime from string in particular format
     * 
     * @param string $s_dtime datetime from database as yyyy-mm-dd hh-mm-ss
     * @param string $format formats output
     * @return string formatted date
     */ 
    static function DateTime ($s_dtime, $format="d M Y")
    {
        // Convert that UNIX Timestamp into a string (GMT), safe for MySql
        $d = strtotime($s_dtime);

        return date($format,$d); // gmdate("d-m-Y", $tring);
    }
    
    /**
     * gets current date
     * @return string formatted date
     */ 
    static private function CurrentDate($format="d M Y")
    {
        return date($format);
    }
    
    /**
     * puts string of date and time into format acceptable by MySQL 4+
     * 
     * @param string $s_dtime some sort of date and time in string accaptable by php function date() in PHP4+
     * @return string formatted datetime
     */ 
    static function DateTimeMySql($s_dtime)
    {
        return self::DateTime($s_dtime, "Y-m-d H:i:s");
    }
    
    
    /**
     * finds object in in array of objects if they are implemented IData interface
     * 
     * @return object or NULL
     */
    static function FindObjectByParam($objects, $param, $value)
    {
        $count = 0;

        while ($count < count($objects))
            if ($objects[$count]->GetValue($param) == $value)
                return $objects[$count];
            else
                $count++;

        return null;
    }


    /**
     * mysql escape string function
     * @param string $param to be escaped
     * @return string of escapded param
     */
    static function mysql_esc($param)
    {
        return mysql_escape_string($param);
    }
    
    
    /**
     * not used
     * reserved for futher use
     * */
    static private function mysql_db ()
    {
        global $sql;
        return $sql;
    }
    
    
    
    
    
    
    // ============================================================================================================================================
    // ====================================================================== CONSTRAINTS ==========================================================
    // ============================================================================================================================================
    
    /**
     * true if has depended records
     */    
    static function CheckConstraintsForRanksById($rank_id)
    {
        global $sql;
        
        if($sql->db_Count(self::$Table_Members,"(*)","WHERE RankID = $rank_id", TE_DEBUG) > 0)
            return true;
        else
            return false;
    }
    
    /**
     * true if has depended records
     */    
    static function CheckConstraintsForGroupsById($group_id)
    {
        global $sql;
        
        if($sql->db_Count(self::$Table_Members,"(*)","WHERE GroupID = $group_id", TE_DEBUG) > 0)
            return true;
        else
            return false;
    }
    
    /**
     * true if has depended records
     */    
    static function CheckConstraintsForLocationsById($location_id)
    {
        global $sql;
        
        if($sql->db_Count(self::$Table_Members,"(*)","WHERE LocationID = $location_id", TE_DEBUG) > 0)
            return true;
        else
            return false;
    }
    
    /**
     * true if has depended records
     */    
    static function CheckConstraintsForAwardsById($award_id)
    {
        global $sql;
        
        if($sql->db_Count(self::$Table_AwardsList,"(*)","WHERE AwardID = $award_id", TE_DEBUG) > 0)
            return true;
        else
            return false;
    }
    
    
    
    
    // ============================================================================================================================================
    // ====================================================================== MEMBERS =============================================================
    // ============================================================================================================================================
    /**
     * inserts new member record into database
     * 
     * @return integer inserted record id
     * 
     */
    static function AddMember($Name, $Status, $Role = "", $ImageUrl = "", $RankID = 0, $LocationID = 0, $ProfileInfo = "", $MemberJoinDate = "", $MemberRankDate = "", $GroupID = 0)
    {
        global $sql;
        
        $_jdate = self::DateTimeMySql(self::mysql_esc($MemberJoinDate));
        
        return $sql->db_Insert(self::$Table_Members, array(
            "Name"              => self::mysql_esc(htmlspecialchars($Name)), 
            "Role"              => self::mysql_esc(htmlspecialchars($Role)), 
            "ImageUrl"          => self::mysql_esc($ImageUrl), 
            "RankID"            => intval($RankID), 
            "Status"            => self::mysql_esc($Status), 
            "LocationID"        => intval($LocationID), 
            "ProfileInfo"       => self::mysql_esc($ProfileInfo), 
            "MemberJoinDate"    => $_jdate, 
            "MemberRankDate"    => $_jdate, 
            "GroupID"           => intval($GroupID)), TE_DEBUG);
    }



    /**
     * updates award's record in db
     * @param integer $idAwards id of rank
     * @param string $Name name of rank
     * @param string $ImageUrl url of image
     * @param string $Description descr
     * @param integer $Order order in a list. Less is Upper
     *  
     * @return integer rows affected. must be equal to 1 (if o.k.). 0 if wrong
     */
    static function UpdateMember($idMembers, $Name, $Status, $RankID, $LocationID, $GroupID, $Role = "", $ImageUrl = "", 
    $ProfileInfo = "", $MemberJoinDate = "", $MemberRankDate = "")
    {
        global $sql;
        $_id = intval($idMembers);
        $_rank_id = intval($RankID);
        $_location_id = intval($LocationID);
        $_group_id = intval($GroupID);
        $_name = self::mysql_esc(htmlspecialchars($Name));
        $_status = self::mysql_esc($Status);
        $_image = self::mysql_esc($ImageUrl);
        $_role = self::mysql_esc($Role);
        $_profile = self::mysql_esc($ProfileInfo);
        $_joindate = self::DateTimeMySql(self::mysql_esc($MemberJoinDate));
        $_rankdate = self::DateTimeMySql(self::mysql_esc($MemberRankDate));

        return $sql->db_Update(self::$Table_Members, 
        "Name = '$_name', ImageUrl = '$_image', Role = '$_role', RankID = $_rank_id, LocationID = $_location_id ,
        GroupID = $_group_id, Status = '$_status', ImageUrl = '$_image', ProfileInfo = '$_profile',
        MemberJoinDate = '".$_joindate."', MemberRankDate = '$_rankdate' WHERE idMembers = $_id", TE_DEBUG);
    }


    /**
     * 
     * deletes member from db
     * 
     * @param TE_Member class $member award to delete
     * 
     * @return integer number rows affected. 0 if failed (of course)
     */
    function DeleteMember($member)
    {
        global $sql;

        if ($member != null)
            return $sql->db_Delete(self::$Table_Members, "idMembers = " . $member->GetValue("idMembers"), TE_DEBUG);
        else
            return 0;
    }


    /**
     * 
     * gets member from its id
     * 
     * @param integer $idMembers member's id
     * @return TE_Member class or null
     */
    static public function GetMemberById($idMembers)
    {
        global $sql;
        $_id = intval($idMembers);
        $member = null;

        $sql->db_Select(self::$Table_Members, "*", "WHERE idMembers = $_id", "", TE_DEBUG);
        $row = $sql->db_Fetch("MYSQL_ASSOC");
        if (!empty($row))
            $member = new TE_Member($row["idMembers"], $row["Name"], $row["Role"],
            $row["ImageUrl"], TE_Manager::GetRankById($row["RankID"]), 
            TE_Manager::GetStatus($row["Status"]), 
            TE_Manager::GetLocationById($row["LocationID"]),
                $row["ProfileInfo"], 
                self::DateTime($row["MemberJoinDate"]), 
                self::DateTime($row["MemberRankDate"]), 
                TE_Manager::GetGroupById($row["GroupID"]),
                0);

        return $member;
    }

    /**
     * 
     * gets all members as TE_Member class array ordered by GroupId
     * 
     * @return TE_Member class array
     */
    static public function GetMembers()
    {
        global $sql;
        $members = array();

        // get locations
        $locations = TE_Manager::GetLocations();
        //get groups
        $groups = TE_Manager::GetGroups();
        // ranks
        $ranks = TE_Manager::GetRanks();
        // get members
        $sql->db_Select(self::$Table_Members, "*", "ORDER BY Name ASC", "", TE_DEBUG);

        while ( ($row = $sql->db_Fetch("MYSQL_ASSOC")) != false) 
            $members[] = new TE_Member($row["idMembers"], 
            $row["Name"], $row["Role"], $row["ImageUrl"], 
            TE_Manager::FindObjectByParam($ranks, "idRanks", $row["RankID"]), 
            TE_Manager::GetStatus($row["Status"]),
            TE_Manager::FindObjectByParam($locations, "idLocations", $row["LocationID"]), 
            $row["ProfileInfo"], 
            self::DateTime($row["MemberJoinDate"]), 
            self::DateTime($row["MemberRankDate"]), 
            TE_Manager::FindObjectByParam($groups, "idGroups", $row["GroupID"]),
            0);
                
        unset($locations);
        unset($groups);
        unset($ranks);
        
        foreach ($members as $member)
            $member->SetAwardsCounter(TE_Manager::CountMemberAwardsByMemberId($member->GetValue("idMembers")));

        if (TE_DEBUG_DUMP)
            foreach ($members as $m)
            {
                var_dump("<br/> ------- member --------> <br/>");
                var_dump($m);
            }

        return $members;
    }
    
    
    
    
    
    // ============================================================================================================================================
    // ==================================================================== AWARDS LIST ===========================================================
    // ============================================================================================================================================
    /**
     * 
     * updates award list for 1 member
     * 
     * @param integer $memder_id member id of member to update list
     * @param integer array $checked_awards award ids of awards checked for member list
     * 
     * @return integer  count of rows affected (deleted and added)
     */ 
    static function UpdateAwardsList($memder_id, array $checked_awards /* new list */)
    {
        global $sql;
        $count = 0;
        $_id = intval($memder_id);
        
        // old list
        $current_awardslist = self::GetAwardsListByMemberId($_id);
        
        if(TE_DEBUG_DUMP)
        {
            var_dump("<br><br>----before: OLD LIST ------<br><br>");
            var_dump($current_awardslist);
            var_dump("<br><br>-----before: NEW LIST-----<br><br>");
            var_dump($checked_awards);
        }
        
        $c_o = 0; // count old list item
        foreach ($current_awardslist as $o)
        {
            $c_n = 0; //count new list item
            foreach  ($checked_awards as $n)
            {
                if ($o->GetValue("AwardID") == $n && !empty($n))
                {
                    unset($current_awardslist[$c_o]);
                    unset($checked_awards[$c_n]);
                    break;
                }
                else
                    $c_n++;
            }
            $c_o++;
        }
        
        if(TE_DEBUG_DUMP)
        {
            var_dump("<br><br>----after: OLD LIST (it will be deleted)------<br><br>");
            var_dump($current_awardslist);
            var_dump("<br><br>-----after: NEW LIST (it will be inserted)-----<br><br>");
            var_dump($checked_awards);
        }
        
        if(!TE_DEBUG_DUMP)
        {
            //do delete
            foreach($current_awardslist as $o)
                $count += $sql->db_Delete(self::$Table_AwardsList,"AwardID = ".$o->GetValue("AwardID")." AND MemberID = ".$o->GetValue("MemberID"), TE_DEBUG);
            
            // do insert
            foreach($checked_awards as $n)
            {
                $sql->db_Insert(self::$Table_AwardsList, array(
                    "AwardID" => $n,
                    "MemberID" => $_id,
                    "GivenDate" => self::DateTimeMySql(self::CurrentDate())),
                    TE_DEBUG);
                    
                $count++;
            }
        }
        
        
        return $count;
    } // UpdateAwardsList (...)
    
    
    
    /**
     * it counts number of awards given for member by its id
     * 
     * @param integer $member_id member's id
     * 
     * @return integer number of awards for current member
     */ 
    static function CountMemberAwardsByMemberId ($member_id)
    {
        global $sql;
        $_id = intval($member_id);
        
        return $sql->db_Count(self::$Table_AwardsList,"(*)","WHERE MemberID = $_id",TE_DEBUG);      
    }


    /**
     * 
     * gets awards' list as TE_AwardsList class array
     * 
     * @return TE_AwardsList class array
     */
    static public function GetAwardsListByMemberId($member_id)
    {
        global $sql;
        $_id = intval($member_id);        
        $awardslist = array();

        $sql->db_Select(self::$Table_AwardsList, "*", "WHERE MemberID = $_id", "", TE_DEBUG);
        
        while ( ($row = $sql->db_Fetch("MYSQL_ASSOC")) != false)
            $awardslist[] = new TE_AwardsList($row["idAwardsList"], $row["AwardID"], $row["MemberID"], self::DateTime($row["GivenDate"]));

        return $awardslist;
    }
    
    
    
    
    
    // ============================================================================================================================================
    // ====================================================================== AWARDS ==============================================================
    // ============================================================================================================================================
    /**
     * inserts new award record into database
     * 
     * @param string $Name name of award
     * @param string $ImageUrl url of image
     * @param string $Description descr
     * @param integer $Order order in a list. Less is Upper
     * 
     * @return integer inserted record id
     */
    static function AddAward($Name = "[Default Award]", $ImageUrl = "", $Description = "", $Order /*topmost*/ )
    {
        global $sql;
        $_name = self::mysql_esc(htmlspecialchars($Name));
        $_image = mysql_escape_string($ImageUrl);
        $_desc = mysql_escape_string($Description);
        $_order = intval($Order);

        return $sql->db_Insert(self::$Table_Awards, 
                                array(
                                "Name" => $_name, 
                                "ImageUrl" => $_image, 
                                "Description" => $_desc, 
                                "MyOrder" => $_order), TE_DEBUG);
    }


    /**
     * updates award's record in db
     * @param integer $idAwards id of rank
     * @param string $Name name of rank
     * @param string $ImageUrl url of image
     * @param string $Description descr
     * @param integer $Order order in a list. Less is Upper
     *  
     * @return integer rows affected. must be equal to 1 (if o.k.). 0 if wrong
     */
    static function UpdateAward($idAwards, $Name, $ImageUrl, $Description, $Order)
    {
        global $sql;
        $_id = intval($idAwards);
        $_name = self::mysql_esc(htmlspecialchars($Name));
        $_image = self::mysql_esc($ImageUrl);
        $_desc = self::mysql_esc($Description);
        $_order = intval($Order);

        return $sql->db_Update(self::$Table_Awards, "Name = '$_name', ImageUrl = '$_image', Description = '$_desc', MyOrder = $_order WHERE idAwards = $_id", TE_DEBUG);
    }


    /**
     * 
     * deletes award from db
     * 
     * @param TE_Award class $award award to delete
     * 
     * @return integer number rows affected. 0 if failed (of course)
     */
    function DeleteAward($award)
    {
        global $sql;

        if ($award != null)
            if(!self::CheckConstraintsForAwardsById($award->GetValue("idAwards")))
            return $sql->db_Delete(self::$Table_Awards, "idAwards = " . $award->GetValue("idAwards"), TE_DEBUG);
        else
            return 0;
    }


    /**
     * 
     * gets award from its id
     * 
     * @param integer $id award's id
     * @return TE_Award class or null
     */
    static public function GetAwardById($idAwards)
    {
        global $sql;
        $_id = intval($idAwards);
        $award = null;

        $sql->db_Select(self::$Table_Awards, "*", "WHERE idAwards = $_id", "", TE_DEBUG);

        if (($row = $sql->db_Fetch("MYSQL_ASSOC")) != null)
            $award = new TE_Award($row["idAwards"], $row["ImageUrl"], $row["Name"], $row["Description"], $row["MyOrder"]);

        return $award;
    }


    /**
     * 
     * gets all award as TE_Award class array
     * 
     * @return TE_Award class array
     */
    static public function GetAwards()
    {
        global $sql;
        $awards = array();
        
        $sql->db_Select(self::$Table_Awards, "*", "ORDER BY MyOrder DESC", "", TE_DEBUG);
        
        while ( ($row = $sql->db_Fetch("MYSQL_ASSOC")) != false)
            $awards[] = new TE_Award($row["idAwards"], $row["ImageUrl"], $row["Name"], $row["Description"], $row["MyOrder"]);

        return $awards;
    }
    
    
    
    
    
    // ============================================================================================================================================
    // ====================================================================== RANKS ===============================================================
    // ============================================================================================================================================
    /**
     * inserts new rank record into database
     * 
     * @param string $Name name of rank
     * @param string $ImageUrl url of image
     * @param string $Description descr
     * @param integer $Order order in a list. Less is Upper
     * 
     * @return integer inserted record id
     */
    static function AddRank($Name = "[Default Rank]", $ImageUrl = "", $Description = "", $Order /*topmost*/ )
    {
        global $sql;
        $_name = mysql_escape_string(htmlspecialchars($Name));
        $_image = mysql_escape_string($ImageUrl);
        $_desc = mysql_escape_string($Description);
        $_order = intval($Order);

        return $sql->db_Insert(self::$Table_Ranks, 
                                array(
                                "Name" => $_name, 
                                "ImageUrl" => $_image, 
                                "Description" => $_desc, 
                                "MyOrder" => $_order), TE_DEBUG);
    }


    /**
     * updates rank's record in db
     * @param integer $idRanks id of rank
     * @param string $Name name of rank
     * @param string $ImageUrl url of image
     * @param string $Description descr
     * @param integer $Order order in a list. Less is Upper
     *  
     * @return integer rows affected. must be equal to 1 (if o.k.). 0 if wrong
     */
    static function UpdateRank($idRanks, $Name, $ImageUrl, $Description, $Order)
    {
        global $sql;
        $_id = intval($idRanks);
        $_name = self::mysql_esc(htmlspecialchars($Name));
        $_image = self::mysql_esc($ImageUrl);
        $_desc = self::mysql_esc($Description);
        $_order = intval($Order);

        return $sql->db_Update(self::$Table_Ranks, "Name = '$_name', ImageUrl = '$_image', Description = '$_desc', MyOrder = $_order WHERE idRanks = $_id", TE_DEBUG);
    }


    /**
     * 
     * deletes rank from db
     * 
     * @param TE_Rank class $rank rank to delete
     * 
     * @return integer number rows affected. 0 if failed (of course)
     */
    function DeleteRank($rank)
    {
        global $sql;

        if ($rank != null)
            if(!self::CheckConstraintsForRanksById($rank->GetValue("idRanks")))
                return $sql->db_Delete(self::$Table_Ranks, "idRanks = " . $rank->GetValue("idRanks"), TE_DEBUG);
        else
            return 0;
    }


    /**
     * 
     * gets rank from its id
     * 
     * @param integer $id rank's id
     * @return TE_Rank class or null
     */
    static public function GetRankById($idRanks)
    {
        global $sql;
        $_id = intval($idRanks);
        $rank = null;

        $sql->db_Select(self::$Table_Ranks, "*", "WHERE idRanks = $_id", "", TE_DEBUG);

        if (($row = $sql->db_Fetch("MYSQL_ASSOC")) != null)
            $rank = new TE_Rank($row["idRanks"], $row["ImageUrl"], $row["Name"], $row["Description"], $row["MyOrder"]);

        return $rank;
    }


    /**
     * 
     * gets all ranks as TE_Rank class array
     * 
     * @return TE_Rank class array
     */
    static public function GetRanks()
    {
        global $sql;
        $ranks = array();

        $sql->db_Select(self::$Table_Ranks, "*", "ORDER BY MyOrder DESC", "", TE_DEBUG);
        
        while ( ($row = $sql->db_Fetch("MYSQL_ASSOC")) != false)
            $ranks[] = new TE_Rank($row["idRanks"], $row["ImageUrl"], $row["Name"], $row["Description"], $row["MyOrder"]);

        return $ranks;
    }


    // ============================================================================================================================================
    // ====================================================================== GROUPS ==============================================================
    // ============================================================================================================================================
    /**
     * inserts new group record into database
     * 
     * @param string $Name name of laction. country
     * @param string $ImageUrl url of image. flag
     * @param string $Description descr
     * @param integer $MaxMembers max members allowed in a group
     * @param integer $Order order in a list. Less is Upper
     * 
     * @return integer inserted record id
     */
    static function AddGroup($Name = "[Default Group]", $ImageUrl = "", $Description = "", $MaxMembers = 0 /*unlimited*/, $Order /*topmost*/ )
    {
        global $sql;
        $_name = mysql_escape_string(htmlspecialchars($Name));
        $_image = mysql_escape_string($ImageUrl);
        $_desc = mysql_escape_string($Description);
        $_max = intval($MaxMembers);
        $_order = intval($Order);

        return $sql->db_Insert(self::$Table_Groups, 
                                array(
                                "Name" => $_name, 
                                "ImageUrl" => $_image, 
                                "Description" => $_desc, 
                                "MaxMembers" => $_max, 
                                "MyOrder" => $_order), TE_DEBUG);
    }


    /**
     * updates group's record in db
     * @param integer $idGroups id of location
     * @param string $Name name of laction. country
     * @param string $ImageUrl url of image. flag
     * @param string $Description descr
     * @param integer $MaxMembers max members allowed in a group
     * @param integer $Order order in a list. Less is Upper
     *  
     * @return integer rows affected. must be equal to 1 (if o.k.). 0 if wrong
     */
    static function UpdateGroup($idGroups, $Name, $ImageUrl, $Description, $MaxMembers, $Order)
    {
        global $sql;
        $_id = intval($idGroups);
      //  $_name = self::mysql_esc(htmlspecialchars($Name)); // secure
       $_name = self::mysql_esc($Name); // unsecure html version
        $_image = self::mysql_esc($ImageUrl);
        $_desc = self::mysql_esc($Description);
        $_max = intval($MaxMembers);
        $_order = intval($Order);

        return $sql->db_Update(self::$Table_Groups, "Name = '$_name', ImageUrl = '$_image', Description = '$_desc', MaxMembers = $_max, MyOrder = $_order WHERE idGroups = $_id", TE_DEBUG);
    }


    /**
     * 
     * deletes group from db
     * 
     * @param TE_Group class $group location to delete
     * 
     * @return integer number rows affected. 0 if failed (of course)
     */
    function DeleteGroup($group)
    {
        global $sql;

        if ($group != null)
            if(!self::CheckConstraintsForGroupsById($group->GetValue("idGroups")))
                return $sql->db_Delete(self::$Table_Groups, "idGroups = " . $group->GetValue("idGroups"), TE_DEBUG);
        else
            return 0;
    }


    /**
     * 
     * gets location from its id
     * 
     * @param integer $id location's id
     * @return TE_Location class or null
     */
    static public function GetGroupById($idGroups)
    {
        global $sql;
        $_id = intval($idGroups);
        $gr = null;

        $sql->db_Select(self::$Table_Groups, "*", "WHERE idGroups = $_id", "", TE_DEBUG);
        $row = $sql->db_Fetch("MYSQL_ASSOC");
        if (!empty($row))
            $gr = new TE_Group($row["idGroups"], $row["Name"], $row["ImageUrl"], $row["Description"], $row["MaxMembers"], $row["MyOrder"]);

        return $gr;
    }


    /**
     * 
     * gets all groups as TE_Group class array
     * 
     * @return TE_Group class array
     */
    static public function GetGroups()
    {
        global $sql;
        $groups = array();

        $sql->db_Select(self::$Table_Groups, "*", "ORDER BY MyOrder DESC", "", TE_DEBUG);
        while ( ($row = $sql->db_Fetch("MYSQL_ASSOC")) != false)
            $groups[] = new TE_Group($row["idGroups"], $row["Name"], $row["ImageUrl"], $row["Description"], $row["MaxMembers"], $row["MyOrder"]);

        return $groups;
    }





    // ============================================================================================================================================
    // ====================================================================== LOCATIONS ===========================================================
    // ============================================================================================================================================
    /**
     * inserts new location record into database
     * 
     * @param string $Name location name. Mostly, it is country
     * @param string $ImageUrl image assigned to location. Mostly it is country flag
     * 
     * @return integer inserted record id
     */
    static function AddLocation($Name, $ImageUrl)
    {
        global $sql;
        $_name = mysql_escape_string(htmlspecialchars($Name));
        $_image = mysql_escape_string($ImageUrl);

        return $sql->db_Insert(self::$Table_Locations, 
                                array(
                                "Name" => $_name, 
                                "ImageUrl" => $_image), TE_DEBUG);
    }


    /**
     * updates location's record in db
     * @param integer $idLocation id of location
     * @param string $Name name of laction. country
     * @param string $Name url of image. flag
     * 
     * @return integer rows affected. must be equal to 1 (if o.k.). 0 if wrong
     */
    static function UpdateLocation($idLocation, $Name, $ImageUrl)
    {
        global $sql;
        $_id = intval($idLocation);
        $_name = self::mysql_esc(htmlspecialchars($Name));
        $_image = self::mysql_esc($ImageUrl);

        return $sql->db_Update(self::$Table_Locations, "Name = '$_name', ImageUrl = '$_image' WHERE idLocations = $_id", TE_DEBUG);
    }


    /**
     * 
     * gets location from its id
     * 
     * @param integer $id location's id
     * @return TE_Location class or null
     */
    function GetLocationById($id)
    {
        global $sql;
        $_id = intval($id);
        $loc = null;

        $sql->db_Select(self::$Table_Locations, "*", "WHERE idLocations = $_id", "", TE_DEBUG);
        $row = $sql->db_Fetch("MYSQL_ASSOC");
        if (!empty($row))
            $loc = new TE_Location($row["idLocations"], $row["Name"], $row["ImageUrl"]);

        return $loc;
    }


    /**
     * 
     * deletes location from db
     * 
     * @param TE_Location class $location location to delete
     * @return integer number rows affected. 0 if failed (of course)
     */
    function DeleteLocation($location)
    {
        global $sql;

        if ($location != null)
            if(!self::CheckConstraintsForLocationsById($location->GetValue("idLocations")))
                return $sql->db_Delete(self::$Table_Locations, "idLocations = " . $location->GetValue("idLocations"), TE_DEBUG);
        else
            return 0;

    }


    /**
     * 
     * gets all locations as TE_Location class array
     * 
     * @return TE_Location class array
     */
    static function GetLocations()
    {
        global $sql;

        $locations = array();

        $sql->db_Select(self::$Table_Locations, "*", "ORDER BY Name ASC", "", TE_DEBUG);

        while (($row = $sql->db_Fetch("MYSQL_ASSOC")) != false)
            $locations[] = new TE_Location($row["idLocations"], $row["Name"], $row["ImageUrl"]);
	
        if (TE_DEBUG_DUMP)
            var_dump($locations);

        return $locations;
        
    }// static function GetLocations()


    // ============================================================================================================================================
    // ====================================================================== STATUSES ============================================================
    // ============================================================================================================================================

    /**
     * -= HARDCODED =-
     * 
     * creates status class for db Status enum
     * it gives color for each.. etc. 
     * 
     * @param string $dbName enum option name (hardcoded in db schema)
     * 
     * @return TE_Status class or NULL
     */
    static function GetStatus($dbName)
    {
        $status = null;
        

        switch ($dbName)
        {
            case "Negotiation":
                $status = new TE_Status($dbName, "TE_Status_Negotiation", TE_Lang::GetLocalized("Negotiation"));
                break;

            case "Declined":
                $status = new TE_Status($dbName, "TE_Status_Declined", TE_Lang::GetLocalized("Declined"));
                break;

            case "Active":
                $status = new TE_Status($dbName, "TE_Status_Active", TE_Lang::GetLocalized("Active"));
                break;

            case "Vacation":
                $status = new TE_Status($dbName, "TE_Status_Vacation", TE_Lang::GetLocalized("Vacation"));
                break;

            case "Suspended":
                $status = new TE_Status($dbName, "TE_Status_Suspended", TE_Lang::GetLocalized("Suspended"));
                break;

            case "Retired":
                $status = new TE_Status($dbName, "TE_Status_Retired", TE_Lang::GetLocalized("Retired"));
                break;

            case "Fired":
                $status = new TE_Status($dbName, "TE_Status_Fired", TE_Lang::GetLocalized("Fired"));
                break;
        }

        return $status;
        
    } //static function GetStatus($dbName)



    /**
     * gets statuses
     * 
     * @return TE_Status array
     */
    static function GetStatuses()
    {
        $statuses = array();
        $db_enum = array("Negotiation", "Declined", "Active", "Vacation", "Suspended", "Retired", "Fired");

        for ($i = 0; $i < count($db_enum); $i++)
            $statuses[] = self::GetStatus($db_enum[$i]);

        return $statuses;
        
    } // static function GetStatuses()
    
    

}



// ================================================= IT IS THE END ===================================================================

?>